##############################################################
### Location + Tomsk Nets v0.52 by Humanoid
### special thanks to nopox                                                       
##############################################################

#setting trigger
bind pub - "!loc" loc:pub


#Some answer strings:
set loc(ok) " " 
set loc(you) " "
set loc(hz) "  "
set loc(er) " -     ;)"

#path to files
set loc(tskbase) "tomsk.csv"
set loc(base) "base.csv"

set loc(ver) "0.52"






### Main script. Don't edit anything below. ###


set loccount 0
set loctskcount 0


set locIP1Array(0) "" 
set locIP2Array(0) "" 
set locCITYArray(0) "" 
set locCOUNTRYArray(0) "" 

set locTskIP1Array(0) "" 
set locTskIP2Array(0) "" 
set locTskPROVArray(0) "" 


proc loc:load {base} {

global loccount
global locIP1Array
global locIP2Array
global locCITYArray
global locCOUNTRYArray
set loccount 0
set locbase [open $base r]


          while {![eof $locbase]} {
            gets $locbase line
        
          
          set locIP1Array($loccount) [lindex [split $line "\t"] 1]
          set locIP2Array($loccount) [lindex [split $line "\t"] 2]

            set locCOUNTRYArray($loccount) [lindex [split $line "\t"] 4]
            set locCITYArray($loccount) [lindex [split $line "\t"] 3]
          
          
#          set locBaseArray($loccount) $line
          
          incr loccount

          }
          close $locbase
 
}


proc loc:tskload {base} {

global loctskcount

global locTskIP1Array 
global locTskIP2Array 
global locTskPROVArray



set loctskcount 0
set locbase [open $base r]


          while {![eof $locbase]} {
            gets $locbase line
        
          set line [split $line ";"]

          #putlog "ip1 [lindex $line 0]"
          set ip1 [ip2longip [lindex $line 0]]
          
          #putlog "ip2 [lindex $line 2]"
          set ip2 [expr $ip1 + [ip2longip "255.255.255.255"] - [ip2longip [lindex $line 2]]]
          
          set provider [join [lrange $line 3 end]]
          #putlog "prov $provider"

          
          set locTskIP1Array($loctskcount) $ip1 
          set locTskIP2Array($loctskcount) $ip2 
          set locTskPROVArray($loctskcount) $provider 

#          set locTskBaseArray($loctskcount) "$ip1 $ip2 $provider"
          
          incr loctskcount

          }
          close $locbase
 
}





proc loc:pub {nick uhost hand chan arg} {

global loc

set arg1 $arg

set ip 0


    if {$arg1==""} {
        set arg1 [lindex [split $uhost @] 1]
    }


    if {[onchan $arg1 $chan]} {
        set arg1 [lindex [split [getchanhost $arg1 $chan] @] 1]
    }


    if {[ishost $arg1]} {

        loc:lookup $nick $uhost $hand $chan $arg $arg1
        return 1
    }

    
    
    if {[isipaddr $arg1]} {
        set ip $arg1
    }


    if {[isvalidip $ip]} {
        set locout [locsearch $ip]

        if {($locout!="")} {
            if {($arg==$ip)} {
                putserv "PRIVMSG $chan : $nick, $ip $loc(ok) $locout"
                return 1
            }   

            if {($arg=="") || ($arg==$nick)} {
                putserv "PRIVMSG $chan : $nick,  \($ip\) $loc(you) $locout"
                return 1
            }   



           if {([onchan $arg $chan])} {
                putserv "PRIVMSG $chan : $nick, $arg \($ip\) $loc(ok) $locout"
                return 1
           }

       } else {

           putserv "PRIVMSG $chan : $nick, $loc(hz) $arg"    
           return 0
       }

    } else {
       putserv "PRIVMSG $chan : $nick, $loc(er)"    
       return 0
    }





        #putlog $ip
}







proc locsearch {ip} {
            
global locIP1Array
global locIP2Array
global locCITYArray
global locCOUNTRYArray


            global loccount
            set i 0

            #putlog $loccount
            while {($i<$loccount)} {

#            set line $locBaseArray($i)
#            putlog $line
          if {[ip2longip $ip] >= $locIP1Array($i)} {
          if {[ip2longip $ip] <= $locIP2Array($i)} {

            set country $locCOUNTRYArray($i)
            set city $locCITYArray($i)
          #  putlog "$country, $city"


           if {$city==""} {
           set city ", $city"           
             return "$country$city[loctsksearch $ip]"
           } else {
            
           if {$city!=""} {           
           set city ", $city"
           }

           return "$country$city"
           }
           
          }
            }
            incr i
    }

            }






proc loctsksearch {ip} {
            
global locTskIP1Array 
global locTskIP2Array 
global locTskPROVArray


            global loctskcount
            set i 0

            #putlog $loctskcount
            while {($i<$loctskcount)} {

#              set line $locTskBaseArray($i)
                #putlog $line
              if {[ip2longip $ip] >= $locTskIP1Array($i)} {
          if {[ip2longip $ip] <= $locTskIP2Array($i)} {


            set prov $locTskPROVArray($i)
            #putlog "$prov"

           return ", $prov"
            break
          }
            }
            incr i
    }

            
            
            return ""
            }





proc loc:lookup {nick uhost hand chan arg host} {

dnslookup $host loc:lookup1 $nick $uhost $hand $chan $arg


}


proc loc:lookup1 {ipaddr hostname status nick uhost hand chan arg} {

global loc

    if {$status==1} {
        set ip $ipaddr

    if {[isvalidip $ip]} {
        set locout [locsearch $ip]

        if {($locout!="")} {

            if {($arg=="") || ($arg==$nick)} {
                putserv "PRIVMSG $chan : $nick,  \($ip\) $loc(you) $locout"
                return 1
            }   

              
              if {([ishost $arg])} {
              putserv "PRIVMSG $chan : $nick, $arg \($ip\) $loc(ok) $locout"
                return 1
              }
    


            if {($arg==$ip)} {
                putserv "PRIVMSG $chan : $nick, $ip $loc(ok) $locout"
                return 1
            }



           if {([onchan $arg $chan])} {
                putserv "PRIVMSG $chan : $nick, $arg \($ip\) $loc(ok) $locout"
                return 1
           }

           } else {
                putserv "PRIVMSG $chan : $nick, $loc(hz) $arg \($ip\)"
                return 0
           }

        } else {
            putserv "PRIVMSG $chan : $nick, $loc(er)"
                return 0
        }

 
  
  } else {
  

putserv "PRIVMSG $chan : $nick, $loc(hz) $arg"
                return 0
  }

  
}




###########################################
# pizded from ip.tcl
###########################################
proc ip2longip {ipaddr} {
  foreach ipbyte [split $ipaddr \x2E] { 
    append hexaddr [format {%02x} $ipbyte] 
  } 
  return [format {%u} "0x$hexaddr"] 
}


proc longip2ip {longip} {
  return [expr {$longip>>24&255}]\x2E[expr {$longip>>16&255}]\x2E[expr {$longip>>8&255}]\x2E[expr {$longip&255}]
}


proc isipaddr {ipaddr} {
  if {[string match -nocase {} $ipaddr]} {
    return 0
  }
  foreach line [split $ipaddr \x2E] {
    if {![regexp ^\[0-9\]+$ $line]} {
      return 0
    } elseif {$line > 255} {
      return 0
    }
    if {[info exists count]} {
      incr count
    } else {
      set count 1
    }
  }
  if {$count != 4} {
    return 0
  } else {
    return 1
  }
}


proc isvalidip {ipaddr} {
  if {(([ip2longip $ipaddr] >= 2130706432) && ([ip2longip $ipaddr] <= 2130706687)) || (([ip2longip $ipaddr] >= 167772160) && ([ip2longip $ipaddr] <= 184549375)) || (([ip2longip $ipaddr] >= 2886729728) && ([ip2longip $ipaddr] <= 2887778303)) || (([ip2longip $ipaddr] >= 3232235520) && ([ip2longip $ipaddr] <= 3232301055)) || (([ip2longip $ipaddr] >= 2851995648) && ([ip2longip $ipaddr] <= 2852061183)) || (([ip2longip $ipaddr] >= 3758096384) && ([ip2longip $ipaddr] <= 4026531839))} {
    return 0
  } else {
    return 1
  }
}



proc reverse_string {arg} {
   set out {}
   foreach line [split $arg {}] {set out $line$out} 
   set out
}



proc ishost {host} {
  foreach {a b} [split [reverse_string $host] \x2E] break
  if {[regexp -all {[a-zA-Z]} $a] && [regexp -all {[a-zA-Z0-9]} $b]} {
    if {![string match -nocase {} $a] && ![string match -nocase {} $b]} {
      return 1
    } else {
      return 0
    }
  } else {
    return 0
  }
}


loc:load $loc(base)
loc:tskload $loc(tskbase)



putlog "*** Location + Tomsk Nets v$loc(ver) Loaded ***"